unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OmegaTimer, OmegaFont, OmegaInput, OmegaImageList, OmegaScreen,
  OmegaSprite;

type
  TKostka=class(TSprite)
  protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );virtual;
    procedure Draw;override;
    procedure Move(const MoveCount:single);override;
  private
   fZmianaMapy:boolean;//czc czwarta
  end;

  TRoslina=class(TKostka)
    k,
    w:integer;  //kolumna i wiersz zaczepienia pnia rosliny
   protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );virtual;
    procedure Move(const MoveCount:single);override;
    procedure onCollision(const Sprite:Tsprite;const colX,colY:integer);override;
  end;
  //*********czc czwarta*************
  TKarczma=class(TRoslina)
   protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );virtual;
  end;
  //
  TGracz=class(TSprite)
  public
    fStop,
    fWBudynku:boolean;//czc czwarta
    fPokryty,
    fKolizja:boolean;
    StareX,
    StareY:single;
    kD,wD,
    k,w:integer;//indeks kolumny i wiersza
    function  Pokryty(x0,y0,_width,_height:single):boolean;
    procedure JakaKostka;
    procedure MoznaIsc;
  protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer//indeks wycinanej klatki
                       );
     procedure Move(const MoveCount:single);override;
     procedure Draw;override;
  end;

  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaInput1: TOmegaInput;
    OmegaFont1: TOmegaFont;
    OmegaTimer1: TOmegaTimer;
    OmegaSprite1: TOmegaSprite;
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    procedure TworzSwiat;
  public
    { Public declarations }
  end;

var
  SkokX,
  SkokY   :single;
  Form1   : TForm1;
  Warstwa1,
  Warstwa0:array[0..19,0..19]of TKostka;//przyjety rozmiar swiata 20x20 kostek
  Gracz   :TGracz;
  Roslina :TRoslina;
  Karczma :TKarczma;
  buforDrogi,
  Drogi   :array of  array of integer;
  procedure wKarczmie;//cz czwarta
  procedure zKarczmy; //cz czwarta
implementation
uses swiatUnit2, UnitStwor000;
{$R *.DFM}
procedure wKarczmie;//cz czwarta
var
 wD,kD,
 i,j:integer;
begin
 for i:=0 to high(Drogi)do
 for j:=0 to high(Drogi[i])do
     begin
      buforDrogi[i,j]:=Drogi[i,j];
      Drogi[i,j]:=-1;
     end;
 for i:=0 to 19 do
 for j:=0 to 19 do begin
     Warstwa0[i,j].ImageIndex:=-1;
     if (i>=9)and(i<=15)and
        (j>=6)and(j<=12)then
        begin
        Warstwa0[i,j].Image:=Form1.OmegaImageList1.ImageList.Items[8];
        Warstwa0[i,j].ImageIndex:=mapaKarczmaWarstwa0[i-9,j-6];
        //wartswa murow
        Warstwa1[i-9,j-6]:=TKostka.Create(Form1.OmegaSprite1,Form1.OmegaImageList1.ImageList.Items[8],mapaKarczmaWarstwa1[i-9,j-6]);
        Warstwa1[i-9,j-6].x:=Warstwa0[i,j].x;
        Warstwa1[i-9,j-6].y:=Warstwa0[i,j].y;
        Warstwa1[i-9,j-6].z:=i+2;
        kD:=(j*Form1.OmegaImageList1.ImageList.Items[0].TileWidth+Form1.OmegaImageList1.ImageList.Items[0].TileWidth div 2) div 32;
        wD:=(i*Form1.OmegaImageList1.ImageList.Items[0].TileHeight)div 32;
        //jesli nie dzrzwi  to zablokuj ruch
        if (mapaKarczmaWarstwa1[i-9,j-6]<>10)and(mapaKarczmaWarstwa1[i-9,j-6]>-1) then begin
          Drogi[wD,kD-1]  :=mapaKarczmaWarstwa1[i-9,j-6];
          Drogi[wD,kD]    :=mapaKarczmaWarstwa1[i-9,j-6];
        end;
        end;
 end;
end;
procedure zKarczmy;//cz czwarta
var
 i,j:integer;
begin
 for i:=0 to high(Drogi)do
 for j:=0 to high(Drogi[i])do
      Drogi[i,j]:=buforDrogi[i,j];
 for i:=0 to 6 do
 for j:=0 to 6 do
     Warstwa1[i,j].Dead;
 for i:=0 to 19 do
 for j:=0 to 19 do begin
     Warstwa0[i,j].Image:=Form1.OmegaImageList1.ImageList.Items[0];
     Warstwa0[i,j].ImageIndex:=mapaWarstwa0[i,j];
   end;
end;
//*******BLOK KOSTEK WIATA*****************************
constructor TKostka.Create(const AParent: TOmegaSprite;
                           const ImageListItem: TImageListItem;
                           const IdKlatka:Integer
                       );
begin
 inherited Create(AParent);
 Image := ImageListItem;
 ImageIndex:=IdKlatka;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
 fZmianaMapy:=false;//cz czwarta
end;
procedure TKostka.Move(const MoveCount:single);
begin
 inherited Move(MoveCount);
 x:=x+SkokX;
 y:=y+SkokY;
end;
procedure TKostka.Draw;
begin
 if ImageIndex<0 then exit;
 inherited Draw;
end;
//*******KONIEC BLOKU KOSTEK WIATA*********************
//*******BLOK KLASY ROSLINA*****************************
constructor TRoslina.Create(const AParent: TOmegaSprite;
                           const ImageListItem: TImageListItem;
                           const IdKlatka:Integer
                       );
begin
 inherited Create(AParent,ImageListItem,IdKlatka);
 Image := ImageListItem;
 ImageIndex:=IdKlatka;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
end;

procedure TRoslina.Move(const MoveCount:single);
begin
 //if TGracz(Gracz).fWBudynku then Visible:=false else Visible:=true;
 //szybciej bdzie tak- wczesniej o tym nie pomylaem
 Visible:=not TGracz(Gracz).fWBudynku;
 inherited Move(MoveCount);
 //przykad prostej metody usuwania testu kolizji
{if (k=TGracz(Gracz).k)
    and
    (w-TGracz(Gracz).w<=2)
    then
    DoCollision:=true else
    DoCollision:=false;}
end;
procedure TRoslina.onCollision(const Sprite:Tsprite;const colX,colY:integer);
begin
  if not Visible then exit;//cz czwarta
  if (Sprite is TGracz)then begin
    TGracz(Sprite).fKolizja:=true;
    TGracz(Sprite).fPokryty:=TGracz(Sprite).Pokryty(x,y,Image.TileWidth,Image.TileHeight);
    if TGracz(Sprite).fPokryty then TGracz(Sprite).Z:=z+1;
  end;
  if (Sprite is TStwor)then begin
    if TStwor(Sprite).fKolizja then exit;
    TStwor(Sprite).fKolizja:=true;
    TStwor(Sprite).fPokryty:=TStwor(Sprite).Pokryty(x,y,Image.TileWidth,Image.TileHeight);
    if TStwor(Sprite).fPokryty then TStwor(Sprite).Z:=z+1;
  end;
end;
//*******KONIEC BLOKU ROSLINA***************************
//czc czwarta
constructor TKarczma.Create(const AParent: TOmegaSprite;
                           const ImageListItem: TImageListItem;
                           const IdKlatka:Integer
                       );
begin
 inherited Create(AParent,ImageListItem,IdKlatka);
 Image := ImageListItem;
 ImageIndex:=IdKlatka;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
end;

//*******BLOK KLASY GRACZ*******************************
procedure TGracz.JakaKostka;
begin
 //policz kol i wiersz w tablicy drog
 kd:=Round(x-Warstwa0[0,0].x+Image.TileWidth  div 2) div 32;
 wd:=Round(y-Warstwa0[0,0].y+Image.TileHeight div 2) div 32;
 if kd<0 then kd:=0;
 if kd>High(Drogi[0]) then kd:=high(drogi[0]);
 if wd<0 then wd:=0;
 if wd>High(Drogi) then wd:=high(drogi);

 //policz kol i wiersz w swiecie warstw i wyznacz Z
 k:=Round(x-Warstwa0[0,0].x+Image.TileWidth  div 2)div Warstwa0[0,0].Image.TileWidth;
 w:=Round(y-Warstwa0[0,0].y+Image.TileHeight div 2)div Warstwa0[0,0].Image.TileHeight;

 if k< 0 then k:=0;
 if k>19 then k:=19;
 if w< 0 then w:=0;
 if w>19 then w:=19;
 z:=w+3;
 //*****cz czwarta************
 if (k=9)and(w=14)and(not fWBudynku)then begin
    fWBudynku:=true;wKarczmie;
 end;
 if (k=9)and(w=15)and(fWBudynku)then begin
    fWBudynku:=false;
    zKarczmy;end;
 end;
procedure TGracz.MoznaIsc;
begin
 //Sterowanie Graczem
 stareX:=x;
 stareY:=y;

 if oisUp in Form1.OmegaInput1.keyboard.states    then//idz do gory
    SkokY:=SkokY+1;
 if oisDown in Form1.OmegaInput1.keyboard.states  then//idz w d
    SkokY:=SkokY-1;
 if oisRight in Form1.OmegaInput1.keyboard.states then//idz w prawo
    SkokX:=SkokX-1;
 if oisLeft in Form1.OmegaInput1.keyboard.states  then//idz w lewo
    SkokX:=SkokX+1;

 x:=x-SkokX;
 y:=y-SkokY;
 JakaKostka;
 //sprwdz czy mona byc w nowej pozycji jak nie to zeruj skok
 //Czc czwarta
 //usun warunek OR, aby mona byo sobie chodzic po caym lesie
 if(Drogi[wd,kd]>-1){or(MapaWarstwa0[w,k]=0)}//mozna ten warunek tak zorganizowac aby dac wszystko do tablicy Drogi
  then begin
    SkokX:=0;//
    SkokY:=0;//
 end;
//ustwa gracza w starej pozycji
 x:=stareX;
 y:=stareY;
end;


procedure TGracz.Move(const MoveCount:single);
begin
 inherited Move(MoveCount);
 fStop:=false;
end;

function  TGracz.Pokryty(x0,y0,_width,_height:single):boolean;
begin
 result:=false;
 if (x>X0)and
    (y+12>y0)and
    (x+Image.TileWidth<x0+_width)and
    (y+Image.TileHeight<y0+_height)
    then result:=true;
end;

procedure TGracz.Draw;
begin
 if not fPokryty then inherited Draw
 else
 Image.Draw(Round(x),Round(y),0,0.5,0.5,1,1,255,0,255,155,ImageIndex,0);

 //Form1.OmegaFont1.Print(Round(x),Round(y),'kd:= '+IntToStr(kd)+'; wd:= '+IntToStr(wd));
 //Form1.OmegaFont1.Print(Round(x),Round(y)+20,'Droga:= '+IntToStr(Drogi[wd,kd]));
 fKolizja:=false;
 fPokryty:=false;
end;
constructor TGracz.Create(const AParent: TOmegaSprite;
                          const ImageListItem: TImageListItem;
                          const IdKlatka:Integer
                       );
begin
 inherited Create(AParent);
 Image        := ImageListItem;
 ImageIndex   :=idKlatka;
 width        :=Image.TileWidth;
 height       :=Image.TileHeight;
 DoCollision  :=true;
 DoPixelCheck :=true;
 //*****cz czwarta*****************
 fWBudynku    :=false; //cz czwarta
end;
//*******KONIEC BLOKU KLASY GRACZ***********************
procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin
 OmegaInput1.Update;
 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
    OmegaScreen1.ToggleFullScreen;
 Gracz.MoznaIsc;
 if not omegascreen1.CanDraw then exit;
 OmegaScreen1.ClearScreen(0,0,0,0);
 OmegaScreen1.BeginRender;

 OmegaSprite1.Collision;


 OmegaSprite1.Dead;
 OmegaSprite1.Draw;
 OmegaSprite1.Move(OmegaTimer1.DeltaSecs); //czesc pita- zamiana miejscami z OmegaSprite1.Draw;

 OmegaFont1.Print(0,20, 'F2 zmiana trybu wywietlania aplikacji');
 OmegaFont1.Print(0,40,'FPS: '+IntToStr(OmegaTimer1.FPS));

 if Gracz.fKolizja then
 OmegaFont1.Print(0,60,'Kolizja');

 OmegaScreen1.EndRender;

 SkokX:=0;
 SkokY:=0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OmegaScreen1.Init;
  OmegaScreen1.SetHWnd(self.handle);
  OmegaFont1.Init;
  OmegaFont1.CreateFont('Arial',8,[]);
  OmegaFont1.Color:=OmegaColor(255,0,0);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OmegaTimer1.Enabled:=false;
  OmegaSprite1.Dead;
  OmegaScreen1.FreeOnRelease;
  if OmegaScreen1.FullScreen then  OmegaScreen1.ToggleFullScreen;
  Drogi:=nil;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 TworzSwiat;
 OmegaTimer1.Enabled:=true;
end;
procedure TForm1.TworzSwiat;
const
 las:array[0..14]of integer=
    (-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
     2,
     3,
     4,
     5,
     6
     );
var
 wD,kD,     //wspolrzedne pnia w siatce Drog
 RozX,RozY, //Rozmiar tablicy siatki Drog
 x,y,k,w,idObraz:integer;
begin
  //buduj tablice drog
  Drogi:=nil;
  buforDrogi:=nil;
  RozX:=(OmegaImageList1.ImageList.Items[0].TileWidth  div 32)*20;
  RozY:=(OmegaImageList1.ImageList.Items[0].TileHeight div 32)*20;
  SetLength(Drogi,RozY,RozX);
  SetLength(buforDrogi,RozY,RozX);
  for w:=0 to rozY-1 do
    for k:=0 to rozX- 1do
     Drogi[w,k]:=-1;//wypenij indeksem wolnych pol

 Randomize;
 //tworz mape swiata
 for w:=0 to high(Warstwa0)do
 for k:=0 to high(Warstwa0[0])do begin
     //wartswa gruntu
     Warstwa0[w,k]:=TKostka.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[0],MapaWarstwa0[w,k]);
     Warstwa0[w,k].x:=k*OmegaImageList1.ImageList.Items[0].TileWidth;
     Warstwa0[w,k].y:=w*OmegaImageList1.ImageList.Items[0].TileHeight;
     Warstwa0[w,k].z:=w;
     Warstwa0[w,k].DoCollision :=false;

     kD:=(k*OmegaImageList1.ImageList.Items[0].TileWidth+OmegaImageList1.ImageList.Items[0].TileWidth div 2) div 32;
     wD:=(w*OmegaImageList1.ImageList.Items[0].TileHeight)div 32;
     //if (MapaWarstwa0[w,k]>0)and(mapaWarstwa1[w,k]=0) then Drogi[wD,kD]:=-1 else Drogi[wD,kD]:=0;
     Drogi[wD,kD]:=-1;
     //tworz losowo drzewa
     if (MapaWarstwa0[w,k]=0)and(mapaWarstwa1[w,k]=0) then begin
        idObraz:=las[RAndom(high(las))];
        if idObraz>-1 then begin
         Roslina:=TRoslina.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[idObraz],0);
         Roslina.x:=k*OmegaImageList1.ImageList.Items[0].TileWidth+
                     (OmegaImageList1.ImageList.Items[0].TileWidth-Roslina.Image.TileWidth)div 2+16;//wyjustuj o 16 wzgledem tablicy Drogi;
         Roslina.y:=w*OmegaImageList1.ImageList.Items[0].TileHeight-(Roslina.Image.TileHeight-OmegaImageList1.ImageList.Items[0].TileHeight);
         Roslina.z:=w+2;
         //zapamietaj kolumne i wiersz zaczepienia rosliny
         Roslina.k:=k;
         Roslina.w:=w;
         Roslina.DoCollision :=true;//false;
         Roslina.DoPixelCheck:=true;
         //zapamietaj pnie drzew
         Drogi[wD,kD]:=idObraz;
        end;
     end;
     //czc czwarta
     //tworz karczm
     if MapaWarstwa1[w,k]=7 then begin
         Karczma:=TKarczma.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[MapaWarstwa1[w,k]],0);
         Karczma.x:=k*OmegaImageList1.ImageList.Items[0].TileWidth+
                     (OmegaImageList1.ImageList.Items[0].TileWidth-Karczma.Image.TileWidth)div 2;//wyjustuj o 16 wzgledem tablicy Drogi;
         Karczma.y:=w*OmegaImageList1.ImageList.Items[0].TileHeight-(Karczma.Image.TileHeight-OmegaImageList1.ImageList.Items[0].TileHeight);
         Karczma.z:=w+2;
         //zapamietaj kolumne i wiersz zaczepienia karczmy
         Karczma.k:=k;
         Karczma.w:=w;
         Karczma.DoCollision :=true;//false;
         Karczma.DoPixelCheck:=true;
         //zapamietaj obszar karczmy
         Drogi[wD,kD-1]:=7;
         //Drogi[wD,kD]:=7;
         Drogi[wD,kD+1]:=7;
         Drogi[wD-1,kD-1]:=7;
         Drogi[wD-1,kD]:=7;
         Drogi[wD-1,kD+1]:=7;
     end;
 end;
 Gracz:=TGracz.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[1],0);
 Gracz.X:=320;
 Gracz.Y:=240;
 //cz piata- tworzenie borostworw
 randomize;
 for k:=0 to 49 do
 begin
  //losuj wsporzedne dla borostwoara- typ 1
  x:=Random(1100)+50;
  y:=Random(600)+20;
  //sprwdz czy w tych wspolrzednych nie ma pni adrzewa
  if Drogi[y div 32,x div 32]=-1 then
  TworzBorostwora(x,y,OmegaSprite1,OmegaImageList1.ImageList.Items[9],1);
  //losuj wsporzedne dla borostwoara- typ 2
  x:=Random(1100)+50;
  y:=Random(600)+20;
  if Drogi[y div 32,x div 32]=-1 then
  TworzBorostwora(x,y,OmegaSprite1,OmegaImageList1.ImageList.Items[10],1);
 end;
end;
procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#27 then close;
end;

end.
